package com.high.master

import android.app.Activity
import android.content.Intent
import android.graphics.Color
import android.os.*
import com.high.pi_framework.Util.FileUtil
import com.high.pi_framework.framework.NewWebViewActivity
import com.high.pi_framework.framework.WebViewActivity
import com.high.pi_framework.webview.YNWebView
import com.quicksdk.QuickSdkSplashActivity
import okhttp3.*
import java.io.IOException
import java.util.concurrent.TimeUnit
import android.icu.lang.UCharacter.GraphemeClusterBreak.T



class SplashActivity : QuickSdkSplashActivity() {
    private var htmlResult: Boolean = false
    private var code = 0
    private var bundle: Bundle? = null

//    override fun onCreate(savedInstanceState: Bundle?){
//        super.onCreate(savedInstanceState)
//        if (!this.isTaskRoot && intent != null) {
//            val action = intent.action
//            if (intent.hasCategory(Intent.CATEGORY_LAUNCHER) && Intent.ACTION_MAIN == action) {
//                finish()
//            }
//        } else {
//            chooceAc()
//        }
//    }

    override fun getBackgroundColor(): Int {
        return Color.WHITE
    }

    override fun onSplashStop() {
        //闪屏结束后，跳转到游戏界面
        chooceAc()
    }

    private fun downloadGameIndex(){
        val url = bundle!!.getString("load_url")
        downloadGameHtml(url!!){ downCode, filePath ->
            htmlResult = true
            if (downCode == 0){
                bundle!!.putString("filePath",filePath)
                bundle!!.putInt("code",0)
            }else{
                bundle!!.putString("filePath",filePath)
                bundle!!.putInt("code",-1)
            }
            startIndex()
        }
    }



    private fun downloadGameHtml(url:String, callBack:(code: Int, filePath: String) -> Unit){
        val timeout = resources.getString(com.high.pi_framework.R.string.down_timeout).toInt()
        val okHttpClient = OkHttpClient.Builder().connectTimeout(timeout.toLong(), TimeUnit.SECONDS).writeTimeout(timeout.toLong(), TimeUnit.SECONDS).readTimeout(timeout.toLong(),
            TimeUnit.SECONDS).build()
        val request = Request.Builder().url(url).get().build()
        val call = okHttpClient.newCall(request)
        call.enqueue(object : Callback {
            override fun onResponse(call: Call?, response: Response?) {
                if(response!!.code() == 200){
                    val context = response.body()!!.string()
                    val file = "$filesDir/game_value/index.html"
                    FileUtil.writeFile(file,context.toByteArray(),false)
                    callBack(0,file)
                }else{
                    callBack(-1,"")
                }
            }
            override fun onFailure(call: Call?, e: IOException?) {
                callBack(-1,"")
            }
        })
    }

    //判断要加载钱包还是游戏
    private fun chooceAc(){
        val game_luanchBoard = resources.getString(R.string.game_luanchBoard)
        val game_name = resources.getString(R.string.game_name)
        val game_url = resources.getString(R.string.game_url)
        bundle = Bundle()
        bundle!!.putString("uagent", "YINENG_ANDROID_GAME/1.0")
        bundle!!.putString("screenOrientation", game_luanchBoard)
        bundle!!.putString("title", game_name)
        bundle!!.putString("load_url", game_url)
        bundle!!.putString("tag", game_name)
        downloadGameIndex()
        code = 1
    }

    private fun startIndex(){
        Handler(Looper.getMainLooper()).post {
            YNWebView.getX5Open { openActivity(code, bundle!!) }
        }
    }

    private fun openActivity(code:Int, bundle: Bundle){
        if (code == 0)startWalletAct()
        else startGameAct(bundle)
    }

    private fun startGameAct( bundle: Bundle ){
        val intent = Intent(this, NewWebViewActivity::class.java)
        intent.putExtras(bundle)
        this.startActivity(intent)
        overridePendingTransition(0, 0)
        finish()
    }

    private fun startWalletAct(){
        val intent = Intent(this, WebViewActivity::class.java)
        startActivity(intent)
        overridePendingTransition(0, 0)
        finish()
    }
}