package com.high.pi_framework.framework

import android.content.*
import android.content.pm.ActivityInfo
import android.os.Build
import android.os.Bundle
import android.os.IBinder
import android.util.Log
import android.widget.RelativeLayout
import com.high.pi_framework.base.BaseWebView
import com.high.pi_framework.module.WebViewManager
import android.view.View
import android.view.ViewTreeObserver
import android.view.Window
import android.view.WindowManager
import com.high.pi_framework.Util.FileUtil
import com.high.pi_framework.Util.ViewUtil
import com.high.pi_framework.webview.YNWebView
import com.high.pi_service.piservice
import com.high.pi_service.piserviceCallBack
import com.high.pi_service.utils.TextUtil
import com.quicksdk.Sdk
import kotlinx.android.synthetic.main.activity_new_web_view.*
import org.json.JSONObject
import java.util.*
import com.quicksdk.QuickSDK
import android.R
import android.app.AlertDialog


class NewWebViewActivity : BaseWebView(), ViewTreeObserver.OnGlobalLayoutListener {
    private var chooceAcPath: String? = null
    private lateinit var mRlRootView: RelativeLayout
    var injectContent: String? = null
    private var screenOrientation: String? = null
    var tag: String? = null
    var url: String? = null
    private var timer: Timer? = null
    private var delay: Long = 2000
    private var ps: piservice? = null
    private val conn = webViewConn()


    override val layoutResources: Int get() = com.high.pi_framework.R.layout.activity_new_web_view

    //=============life================
    override fun onCreate(savedInstanceState: Bundle?) {
        Log.d("NewWebViewActivity", "onCreate new WebView: " + intent?.getStringExtra("tag"))
        chooceAcPath = filesDir.absolutePath + "/chooseAc.json"
        hideSystemNavigationBar()
        bindYnWebView()
        super.onCreate(savedInstanceState)
        if (resources.getString(com.high.pi_service.R.string.start_vm) != "false")rsgService()
        Sdk.getInstance().onCreate(this)
    }


    override fun initViews() {
        mRlRootView = root_view
        if (screenOrientation != "landscape"){
            boot_view.layoutParams.height = ViewUtil.getStatusBarHeight(this).toInt()
        }
        mRlRootView.viewTreeObserver.addOnGlobalLayoutListener(this)
        mRlRootView.removeAllViews()
        ynWebView.addYnWebView(mRlRootView)
    }

    override fun initData() {
        YNWebView.addWithName(tag!!,ynWebView)
        Log.d("WebView", "new WebView: " + intent?.getStringExtra("tag"))
        if (null == tag) throw Exception("The tag can't be null!")
        url = intent?.getStringExtra("load_url") ?: resources.getString(com.high.pi_framework.R.string.game_url)
        val tagStr = tag as String
        ynWebView.addNewJavaScript( mRlRootView, tagStr, url!!)
        startLoadUrl()
        registerCloseReceiver()
    }

    override fun onStart() {
        super.onStart()
        Sdk.getInstance().onStart(this)
    }

    override fun onRestart() {
        Log.d("NewWebViewActivity", "onRestart")
        super.onRestart()
        Sdk.getInstance().onRestart(this)
        JSBridge.sendJS(ynWebView,"PI_App", ON_APP_RESUMED, arrayOf("App进入前台"))
    }

    override fun onBackPressed() {
        if (QuickSDK.getInstance().isShowExitDialog) {
            Sdk.getInstance().exit(this)
        } else {
            // 游戏调用自身的退出对话框，点击确定后，调用quick的exit接口
            AlertDialog.Builder(this).setTitle("退出").setMessage("是否退出游戏?").setPositiveButton("确定") { _, _ -> Sdk.getInstance().exit(this) }.setNegativeButton("取消", null).show()
        }
    }

    override fun onNewIntent(intent: Intent?) {
        Log.d("NewWebViewActivity","onNewIntent with this tag is $tag")
        super.onNewIntent(intent)
        Sdk.getInstance().onNewIntent(intent)
        if (intent?.getStringExtra("tag") == null)return
        if (tag != intent.getStringExtra("tag") && tag != null){
            screenOrientation = intent.getStringExtra("screenOrientation")
            Log.d("NewWebViewActivity","screenOrientation $screenOrientation")
            if (screenOrientation == "portrait"){
                requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
            }else{
                requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE
            }
            if (WebViewManager.isGameViewExists(tag!!)) WebViewManager.removeGameView(tag!!)
            if( tag!! in YNWebView.managerMap.keys) YNWebView.managerMap.remove(tag!!)
            tag = intent.getStringExtra("tag")
            if (resources.getString(com.high.pi_service.R.string.start_vm) != "false"){unbindService(conn);rsgService()}
            Log.d("NewWebViewActivity","onNewIntent with new tag is $tag")
            if (null == tag) throw Exception("The tag can't be null!")
            YNWebView.addWithName(tag!!, ynWebView)
            url = intent?.getStringExtra("load_url") ?: resources.getString(com.high.pi_framework.R.string.game_url)
            val tagStr = tag as String
            ynWebView.addWebViewManager(tagStr)
            startLoadUrl()
            saveChooseAc()
        }
    }

    override fun onPause() {
        super.onPause()
        Sdk.getInstance().onPause(this)
    }

    override fun onResume() {
        Log.d("NewWebViewActivity", "onResume")
        super.onResume()
        Sdk.getInstance().onResume(this)
        saveChooseAc()
    }
    override fun onStop() {
        Log.d("NewWebViewActivity", "onStop")
        super.onStop()
        Sdk.getInstance().onStop(this)
    }

    override fun onDestroy() {
        Log.d("NewWebViewActivity", "onDestroy")
        unbindService(conn)
        WebViewManager.removeGameView(this.tag!!)
        unregisterReceiver(mCloseReceiver)
        super.onDestroy()
        Sdk.getInstance().onDestroy(this)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        ynWebView.iterationOnActivityResult(requestCode, resultCode, data)
        super.onActivityResult(requestCode, resultCode, data)
        Sdk.getInstance().onActivityResult(this, requestCode, resultCode, data)
    }

    override fun onGlobalLayout() {
        if (timer != null){
            timer!!.cancel()
            timer!!.purge()
        }
        timer = Timer()
        val task = object : TimerTask() {
            override fun run() {
                mRlRootView.post { kotlin.run { hideNavigation() } }
            }
        }
        timer!!.schedule(task,delay)
    }


    //============public================
    fun startLoadUrl(){
        saveChooseAc()
        if (intent.getIntExtra("code",0)== -1)loadUrlImpl(false)
        else { injectContent = FileUtil.readFile(intent.getStringExtra("filePath")); loadUrlImpl(true)}
    }

    fun loadUrlImpl(result: Boolean) {
        var fullUrl = this.url.toString()
        val gameJsonStream = this.assets.open("game.json")
        val gameJson = FileUtil.readFile(gameJsonStream)
        val gameObject = JSONObject(gameJson)
        var bool = false
        val gameList = gameObject.keys()
        for (name in gameList){
            Log.d("NewWebViewActivity","game.json read key is $name")
            if (name == this.tag){
                bool = true
                break
            }
        }
        if (bool){
            fullUrl = gameObject[this.tag].toString()
            loadBaseUrl(result, "file:///android_asset" + fullUrl, this.injectContent)
        } else {
            loadBaseUrl(result, fullUrl, this.injectContent)
        }
    }

    fun loadBaseUrl(result: Boolean, url: String, content: String?){
        if (result)  ynWebView.loadDataWithBaseUrl(url, content!!)
        else{
            val stream = this.assets.open("init.html")
            val ct = FileUtil.readFile(stream)
            ynWebView.loadDataWithBaseUrl( url, ct)
        }
    }

    fun webViewPostMessage(sender: String, message: String){
        if (ps != null){
            val ms = "window.onWebViewPostMessage('$sender','$message')"
            ps!!.sendMessage(tag, ms)
        }
    }


    fun webViewBindService(message: String){
        if (ps != null){
            val ms = "window['handle_native_event']('ServiceAction', 'bind','$tag','$message')"
            ps!!.sendMessage(tag, ms)
        }
    }
    fun minsizeActivity(webViewName: String, webUrl: String){
        val minintent = Intent(this, WebViewActivity::class.java)
        minintent.addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT)
        if(webUrl != "") {
            minintent.putExtra("webUrl", webUrl)
            minintent.putExtra("iswallet",false)
        }else {
            minintent.putExtra("iswallet",true)
        }
        startActivity(minintent)
    }


    //============private===============

    private fun saveChooseAc(){
        val js = JSONObject()
        js.put("iswallet","false")
        js.put("game_luanchBoard",screenOrientation)
        js.put("game_name",tag)
        js.put("game_url",url)
        FileUtil.writeFile(chooceAcPath, js.toString().toByteArray(), false)
    }

    private fun rsgService(){

        val pkgName = applicationContext.packageName
        val intentName = "$pkgName.piservice"
        Log.d("framework", "NewWebViewActivity: Package Name = $pkgName, Intent Name = $intentName")
        val intent = Intent(intentName)
        intent.setPackage(pkgName)
        bindService(intent, conn, BIND_AUTO_CREATE)
    }

    private fun bindYnWebView(){
        tag = intent!!.getStringExtra("tag")
        if(tag == null){
            tag = resources.getString(com.high.pi_framework.R.string.game_name)
        }
        val uAgent = intent?.getStringExtra("uagent")
        if ( uAgent != null){
            ynWebView.createYnWebView(this, uAgent)
        }else{
            ynWebView.createYnWebView(this)
        }
        addJEV(this)
    }


    fun closeActivicty(){
        val closeIntent = Intent(this, WebViewActivity::class.java)
        closeIntent.addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT)
        startActivity(closeIntent)
        finish()
    }

    private fun changeScreen(){
        screenOrientation = intent?.getStringExtra("screenOrientation")?: resources.getString(com.high.pi_framework.R.string.game_luanchBoard)
        Log.d("NewWebViewActivity","screenOrientation is $screenOrientation, intent string is ${intent?.getStringExtra("screenOrientation")}")
        if (screenOrientation == "portrait"){
            requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
        }else{
            requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE
        }
    }

    private fun hideSystemNavigationBar() {
        changeScreen()
        if(screenOrientation == "landscape"){
            // 刘海屏适配
            requestWindowFeature(Window.FEATURE_NO_TITLE)
            val window = window
            // 如果需要设置全屏
            window.setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN)
            requestWindowFeature(Window.FEATURE_NO_TITLE) // 隐藏状态栏
        }
        hideNavigation()
    }

    private fun hideNavigation(){
        if (screenOrientation == "landscape"){
            window.decorView.systemUiVisibility = View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION or View.SYSTEM_UI_FLAG_FULLSCREEN or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.P) {
                val lp = window.attributes
                lp.layoutInDisplayCutoutMode =
                    WindowManager.LayoutParams.LAYOUT_IN_DISPLAY_CUTOUT_MODE_SHORT_EDGES
                window.attributes = lp
            }
        }else{
            val params = window.attributes
            params.systemUiVisibility =   View.SYSTEM_UI_FLAG_HIDE_NAVIGATION or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY
            window.attributes = params

        }

    }

    private fun registerCloseReceiver() {
        val intentFilter = IntentFilter()
        intentFilter.addAction("close_web_view")
        intentFilter.addAction("send_message$tag")
        registerReceiver(mCloseReceiver, intentFilter)
    }


    private val mCloseReceiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context?, intent: Intent?) {
            val action = intent?.action ?: return
            when (action) {
                "close_web_view" -> {
                    if (tag == intent.getStringExtra("web_view_name")) {
                        this@NewWebViewActivity.closeActivicty()
                    }
                }
                "send_message$tag" -> {
                    val rpc = intent.getStringExtra("rpc")
                    val message = intent.getStringExtra("message")
                    val sender = intent.getStringExtra("from_web_view")
                    if (rpc == "true"){
                        val callFun = String.format("javascript:window.onWebViewPostMessage('%s','%s')", sender, message)
                        ynWebView.evaluateJavascript(callFun)
                    }else{
                        ynWebView.evaluateJavascript(message)
                    }
                }
            }
        }
    }

    inner class webViewConn(): ServiceConnection {
        override fun onServiceConnected(name: ComponentName?, service: IBinder?) {
            ps = piservice.Stub.asInterface(service)
            ps!!.onMessage(tag, object : piserviceCallBack.Stub(){
                override fun sendMessage(statuCode: Int, message: String?) {
                    var ms = ""
                    var newMessage = TextUtil.resetSpecialCharInString(message!!)
                    Log.d("piservice","javascript:statuCode:$statuCode=======message:$newMessage")
                    if (statuCode == 200){
                        ms = "javascript:window.pi_sdk.piService.onBindService(undefined, '$newMessage')"
                    }else if(statuCode == 400){
                        ms = "javascript:window.pi_sdk.piService.onBindService({code: -4, reason: $newMessage},undefined)"
                    }else if (statuCode == 600){
                        ms = String.format("javascript:window.onWebViewPostMessage('%s','%s')", "JSVM", newMessage)
                    }
                    runOnUiThread { ynWebView.evaluateJavascript(ms) }
                }
            })
        }

        override fun onServiceDisconnected(name: ComponentName?) {

        }
    }
}

