package com.high.pi_framework.module

import android.app.AlarmManager
import android.app.PendingIntent
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.support.v7.app.AlertDialog
import android.util.Log
import com.high.pi_framework.R
import com.high.pi_framework.base.BaseJSModule
import com.high.pi_framework.framework.NewWebViewActivity
import com.high.pi_framework.framework.WebViewActivity
import com.high.pi_framework.webview.YNWebView
import kotlin.system.exitProcess

class ExitApp(ynWebView: YNWebView) : BaseJSModule(ynWebView) {
    /**
     * The method will be called when the web view couldn't back anymore
     * and the user still press key-back.
     * Then there is a dialog to show the message tell:
     * confirm exit?
     *
     */
    init {
        Log.d("ExitAPP", "now ExitApp is Init")


    }

    fun confirmExit(callBack:(callType: Int, prames: Array<Any>)->Unit) {
        val dialog = AlertDialog.Builder(ctx!!)
            .setTitle(ctx!!.resources.getString(R.string.dialog_title_prompt))
            .setMessage(ctx!!.resources.getString(R.string.dialog_msg_confirm_exit_app))
            .setCancelable(true)
            .setPositiveButton(ctx!!.resources.getString(R.string.dialog_title_ok)) { dialog, which -> ctx!!.finish() }
            .create()
        dialog.setCanceledOnTouchOutside(false)
        dialog.show()
    }

    /**
     * Back to home screen instead of the exit application,
     * if you call this function,the application will always run in the background.
     *
     * @param callbackId This method is would be called by TS,this value from ts.
     */
    fun backToHome(callBack:(callType: Int, prames: Array<Any>)->Unit) {
        val home = Intent(Intent.ACTION_MAIN)
        home.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
        home.addCategory(Intent.CATEGORY_HOME)
        ctx!!.startActivity(home)
    }

    fun restart(callBack:(callType: Int, prames: Array<Any>)->Unit) {
        Log.d("Restart","重启!!!")
        val mStartActivity : Intent = ctx!!.packageManager.getLaunchIntentForPackage(ctx!!.packageName);
        var mPendingIntentId : Int  = 123456
        var mPendingIntent : PendingIntent = PendingIntent.getActivity(ctx, mPendingIntentId, mStartActivity, PendingIntent.FLAG_CANCEL_CURRENT);
        var mgr : AlarmManager = ctx!!.getSystemService(Context.ALARM_SERVICE) as AlarmManager
        mgr.set(AlarmManager.RTC, System.currentTimeMillis() + 50, mPendingIntent)
        // System.exit(0)
        exitProcess(0)
    }
    private var restartHigh = object : BroadcastReceiver(){
        override fun onReceive(context: Context?, intent: Intent?) {
            Log.d("Restart","重启!!!!")
            val mStartActivity : Intent = ctx!!.packageManager.getLaunchIntentForPackage(ctx!!.packageName);
            var mPendingIntentId : Int  = 123456
            var mPendingIntent : PendingIntent = PendingIntent.getActivity(ctx, mPendingIntentId, mStartActivity, PendingIntent.FLAG_CANCEL_CURRENT);
            var mgr : AlarmManager = ctx!!.getSystemService(Context.ALARM_SERVICE) as AlarmManager
            mgr.set(AlarmManager.RTC, System.currentTimeMillis() + 50, mPendingIntent)
            // System.exit(0)
            exitProcess(0)
        }
    }
}


