package com.high.pi_service.utils

import android.Manifest
import android.content.Context
import android.net.ConnectivityManager
import android.net.wifi.WifiManager
import com.github.dfqin.grantor.PermissionListener
import com.github.dfqin.grantor.PermissionsUtil

object ipc4AddressUtil{
    fun getipv4AddressUtil(context: Context, cb: (code:Int, ipv4: String) -> Unit){
        PermissionsUtil.requestPermission(context, object : PermissionListener {
            override fun permissionDenied(permission: Array<out String>) {

            }
            override fun permissionGranted(permission: Array<out String>) {
                val info = (context.getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager).activeNetworkInfo
                if (info != null && info.isConnected ){
                    if (info.type == ConnectivityManager.TYPE_WIFI){
                        val wifiManager = context.applicationContext.getSystemService(Context.WIFI_SERVICE) as WifiManager
                        val wifiInfo = wifiManager.connectionInfo
                        val ipAddress = intIP2StringIP(wifiInfo.ipAddress)
                        cb(0,ipAddress)
                    }else{
                        cb(-1,"not in wifi")
                    }
                }else{
                    cb(-1,"can not get internet")
                }
            }
        }, arrayOf(Manifest.permission.ACCESS_NETWORK_STATE, Manifest.permission.ACCESS_WIFI_STATE),true,
            PermissionsUtil.TipInfo("提示","当前应用缺少必要权限。\\n \\n请点击\"设置\"-\"权限\"-打开所需权限。", "取消","确定"))
    }

    private fun intIP2StringIP(ip: Int): String{
        return (ip and 0xFF).toString() + "." +
                ((ip shr 8) and 0xFF).toString() + "." +
                ((ip shr 16) and 0xFF).toString() + "." +
                (ip shr 24 and 0xFF).toString();
    }

}